//提出用エージェントベース

package org.aiwolf.MayQueen;

import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Status;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MyBasePlayer implements Player {

	// ⾃分⾃⾝
	Agent me;

	// ⽇付
	int day;

	// エージェントの数
	int numAgents;

	/** talk()できるか時間帯か */
	boolean canTalk;

	/** whisper()できるか時間帯か */
	boolean canWhisper;

	// 最新のゲーム情報
	GameInfo currentGameInfo;

	/** エージェントが殺されたかどうかを返す */
	protected boolean isKilled(Agent agent) {
		return killedAgents.contains(agent);
	}

	/** エージェントがカミングアウトしたかどうかを返す */
	protected boolean isCo(Agent agent) {
		return comingoutMap.containsKey(agent);
	}

	/** 役職がカミングアウトされたかどうかを返す */
	protected boolean isCo(Role role) {
		return comingoutMap.containsValue(role);
	}

	// ⾃分以外の⽣存エージェント
	List<Agent> aliveOthers;

	//全エージェント
	List<Agent> Others;

	// 追放されたエージェント
	List<Agent> executedAgents = new ArrayList<Agent>();

	// 殺されたエージェント
	List<Agent> killedAgents = new ArrayList<Agent>();

	// 発言用待ち行列
	Deque<Content> talkQueue = new LinkedList<Content>();

	/** 囁き用待ち行列 */
	Deque<Content> whisperQueue = new LinkedList<>();

	// 占い師の発⾔内容リスト
	List<Judge> divinationList = new ArrayList<Judge>();

	// 投票先候補
	Agent voteCandidate;

	// 宣⾔済み投票先候補
	Agent declaredVoteCandidate;

	/** 襲撃投票先候補 */
	Agent attackVoteCandidate;

	//襲撃先候補
	Agent AttackVoteCandidate;

	/** 白判定エージェントリスト */
	Set<Agent> whiteDivineList = new HashSet<Agent>();

	/** 宣言済み襲撃投票先候補 */
	Agent declaredAttackVoteCandidate;

	// カミングアウト状況
	Map<Agent, Role> comingoutMap = new HashMap<Agent, Role>();

	// talkListの読み込みヘッド
	int talkListHead;

	/** 人間リスト */
	List<Agent> humans = new ArrayList<>();

	/** 人狼リスト */
	List<Agent> werewolves = new ArrayList<>();

	/** COしていないもしくは誰にも占われていないプレイヤ */
	//List<Agent> noCodivined;

	/**疑い度マップ */
	Map<Agent, Integer> DoubtMap ;
	/**疑い度を低い順にするリスト */
	List<Agent> minsortDoubtList=new ArrayList<Agent>();

	/** 黒判定エージェントリスト */
	Set<Agent> blackDivineList = new HashSet<Agent>();

	/** まだ確定していないエージェントリスト */
	List<Agent> GrayList = new ArrayList<Agent>();
	/** 人狼と判断したエージェントリスト */
	List<Agent> BlackList = new ArrayList<Agent>();



	/** エージェントが⽣きているかどうかを返す */
	protected boolean isAlive(Agent agent) {
		return currentGameInfo.getStatusMap().get(agent) == Status.ALIVE;
	}

	/** 人間かどうかを返す */
	protected boolean isHuman(Agent agent) {
		return humans.contains(agent);
	}

	/** 人狼かどうかを返す */
	protected boolean isWerewolf(Agent agent) {
		return werewolves.contains(agent);
	}

	/** リストからランダムに選んで返す */
	protected <T> T randomSelect(List<T> list) {
		if (list.isEmpty()) {
			return null;
		} else {
			return list.get((int) (Math.random() * list.size()));
		}
	}

	/** 人狼の数*/
	protected int numWolves() {
		if(numAgents == 5){
			return 1;
		}else{
			return 3;
		}
	}

	@Override
	public String getName() {
		return "MyBasePlayer";
	}




	// ゲームごとに初期化しておきたい変数などの処理を書く
	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		currentGameInfo = gameInfo; // GameInfoを取得
		me = currentGameInfo.getAgent(); // ⾃分の情報を取得
		day = -1; // ⽇付を初期化(-1)
		aliveOthers = currentGameInfo.getAliveAgentList(); // ⽣存エージェントを取得
		Others = currentGameInfo.getAgentList();//エージェント全てを取得
		aliveOthers.remove(me); // ⾃分を⽣存リストの中から削除
		executedAgents.clear(); // 追放エージェントリストを初期化(クリア)
		killedAgents.clear();// 殺されたエージェントリストを初期化(クリア)
		divinationList.clear(); // 占い報告リストを初期化(クリア)
		comingoutMap.clear(); // COマップをクリア(初期化)
		numAgents = gameInfo.getAgentList().size();// エージェント数を取得
		DoubtMap = new HashMap<Agent, Integer>();
		for(Agent agent : aliveOthers) {
			DoubtMap.put(agent, 50);
		}
	}

	//⽇ごとに初期化しておきたい変数などの処理を書く
	@Override
	public void dayStart() {
		// TODO 自動生成されたメソッド・スタブ

		talkQueue.clear(); // 発⾔キューの初期化
		voteCandidate = null; // 投票先候補の初期化(null)
		declaredVoteCandidate = null; // 宣⾔済み投票先候補の初期化(null)
		talkListHead = 0; // talkListの読み込みヘッドの初期化(0)

		// 追放エージェントをリストに追加
		Agent executedAgent = currentGameInfo.getExecutedAgent(); // 追放エージェント取得
		if (executedAgent != null) { // 追放エージェントがnullでなければ
			aliveOthers.remove(executedAgent); // ⽣存エージェントリストから削除
			DoubtMap.remove(executedAgent);
			if (!executedAgents.contains(executedAgent)) { // 追放されたエージェントリストに未追加状態なら
				executedAgents.add(executedAgent); // 追放されたエージェントリストに追加
			}
		}

		// 殺されたエージェントをリストに追加
		if (!currentGameInfo.getLastDeadAgentList().isEmpty()) { // 昨夜殺されたエージェントがいるならば
			Agent killedAgent = currentGameInfo.getLastDeadAgentList().get(0); // 殺されたエージェント取得
			if (killedAgent != null) { // 殺されたエージェントがnullでなければ
				aliveOthers.remove(killedAgent); // ⽣存エージェントリストから削除
				DoubtMap.remove(killedAgent);
				if (!killedAgents.contains(killedAgent)) { // 殺されたエージェントリストに未追加状態なら
					killedAgents.add(killedAgent); // 殺されたエージェントリストに追加
				}
			}
		}

	}

	@Override
	public void update(GameInfo gameInfo) {

		currentGameInfo = gameInfo; // currentGameInfoの更新
		if (currentGameInfo.getDay() == day + 1) { // 1⽇の最初の呼び出しの場合
			day = currentGameInfo.getDay(); //⽇付の更新
			return;
		}

		// 追放されたエージェントの登録(役職持ちが夜の⾏動に使えるように)
		Agent executedAgent = currentGameInfo.getLatestExecutedAgent(); // 追放エージェント取得
		if (executedAgent != null) { // 追放エージェントがnullでなければ
			aliveOthers.remove(executedAgent); // ⽣存エージェントリストから削除
			DoubtMap.remove(executedAgent);
			if (!executedAgents.contains(executedAgent)) { // 追放されたエージェントリストに未追加状態なら
				executedAgents.add(executedAgent); // 追放されたエージェントリストに追加
			}
		}

		 if(!currentGameInfo.getLastDeadAgentList().isEmpty()) { // 昨夜殺されたエージェントがいるならば
			 Agent killedAgent = currentGameInfo.getLastDeadAgentList().get(0); // 殺されたエージェント取得
			 if(killedAgent != null) { // 殺されたエージェントがnullでなければ
				 aliveOthers.remove(killedAgent); // ⽣存エージェントリストから削除
				 //noCodivined.remove(killedAgent);
				 GrayList.remove(killedAgent);
				 BlackList.remove(killedAgent);
				 DoubtMap.remove(killedAgent);
				 if(!killedAgents.contains(killedAgent)) { // 殺されたエージェントリストに未追加状態なら
					 killedAgents.add(killedAgent); // 殺されたエージェントリストに追加
				 }
			 }
		 }

		// GameInfo.talkListからCO，占い結果を抽出
		for (int i = talkListHead; i < currentGameInfo.getTalkList().size(); i++) { // 前回までに読んだ場所の次から解析
			Talk talk = currentGameInfo.getTalkList().get(i); // i番⽬のトーク取得
			Agent talker = talk.getAgent(); // 発話者を取得
			if (talker == me) { // 発話者が⾃分の場合は無視
				continue;
			}
			Content content = new Content(talk.getText()); // Content型に変換
			if (content.getSubject() == Content.UNSPEC) { // 主語が省略されている場合
				if (content.getTopic() != Topic.SKIP && content.getTopic() != Topic.OVER) { // SKIPでもOVERでもなければ
					content = new Content(talker + " " + Content.stripSubject(content.getText())); // 主語を発話者に置き換える
				}
			}
			parseSentence(content); // 解析
		}
		talkListHead = currentGameInfo.getTalkList().size(); // talkListHeadを今のリストのサイズに置き換えておく(次回の読み始め位置)

	}





	/** 投票先候補を選びvoteCandidateにセットする */
	protected void chooseVoteCandidate() {
	}
	protected Agent chooseVote() {
		return null;
	}
	@Override
	public Agent vote() {
		return chooseVote();
	}

	protected String chooseTalk() {
		if (talkQueue.isEmpty()) { // 発⾔キューが空なら
			return Talk.SKIP; // SKIPを返す
		}
		Content content = talkQueue.pollFirst(); // 発⾔キューからContentを取得
		if (content != null) { // contentがnull以外なら
			return content.getText(); // String型に変えてreturn
		} else { // contentがnullなら
			return Talk.SKIP; // SKIPを返す
		}
	}
	@Override
	public String talk() {
		return chooseTalk();
	}

	protected void chooseAttackVoteCandidate() {
	}
	protected Agent attackVote() {
		return null;
	}
	@Override
	public Agent attack() {
		return attackVote();
	}

	@Override
	public String whisper() {
		return (new Content(new ComingoutContentBuilder(me, Role.WEREWOLF))).getText();
	}

	@Override
	public Agent guard() {
		return null;
	}

	@Override
	public Agent divine() {
		return null;
	}



	// ⽂を解析
	void parseSentence(Content content) {
		switch (content.getTopic()) { // Topicで処理を分ける
		case COMINGOUT: // カミングアウト
			comingoutMap.put(content.getTarget(), content.getRole()); // COマップに追加
			return;
		case DIVINED: // 占い結果
			// 占い結果リストに追加
			divinationList.add(new Judge(day, content.getSubject(), content.getTarget(), content.getResult()));
			return;
		case IDENTIFIED: // 霊媒結果の処理は省略
			return;
		case OPERATOR: // 演算⼦
			parseOperator(content); // 演算⼦解析に渡す
			return;
		default:
			break;
		}
	}

	// 演算⼦を解析
	void parseOperator(Content content) {
		switch (content.getOperator()) { // Operatorで処理を分ける
		case BECAUSE: //because(理由)
			parseSentence(content.getContentList().get(1)); // 理由は無視して，結果のみ解析
			break;
		case DAY: //day(⽇付)
			parseSentence(content.getContentList().get(0)); // 内容のみ再解析
			break;
		case AND:
			/*and(全てがtrue)*/ case OR:
			/*or(どれかがtrue)*/ case XOR: /*xor(どちらかがtrue)*/
			for (Content c : content.getContentList()) { // 全ての⽂を分割して再解析
				parseSentence(c);
			}
			break;
		case REQUEST:
			/*request(要求)*/ case INQUIRE: /*inquire(状態を聞く)*/
			break; // 省略
		default:
			break;
		}
	}

	void DoubtAddRemove(Agent agent) {
		if(!BlackList.contains(agent) && aliveOthers.contains(agent)) {//Blacklistにいないかつ，生きている場合のみ追加する
			BlackList.add(agent);
			GrayList.remove(agent);
			DoubtMap.remove(agent);
			minSort();//信頼度を小さい順にする
		}
	}
	public void Doubt(Agent agent ,int value) {
		if(agent==me || !DoubtMap.containsKey(agent)) return;
		int Doubt=DoubtMap.get(agent)+value;
		if(Doubt>100) {
			Doubt=100;
		}else if(Doubt<0) {
			Doubt=0;
		}
		DoubtMap.replace(agent, Doubt);
	}
	void minSort() {//信頼度を低い順にする

		minsortDoubtList.clear();

		Map<Agent, Integer> mintargetMap= new HashMap<Agent, Integer>(DoubtMap);
		while (!mintargetMap.isEmpty()) {
			//System.out.println(mintargetMap);
			//System.out.println(DoubtMap);

			int minDoubt=101;
			Agent target=null;
			for(Agent agent:mintargetMap.keySet()) {//一番信頼度の低いエージェントを選択
				if(minDoubt > mintargetMap.get(agent)) {
					minDoubt=mintargetMap.get(agent);
					target=agent;
				}
			}
			minsortDoubtList.add(target);
			mintargetMap.remove(target);//
		}
	}



	@Override
	public void finish() {
		WinRateCalc.updateWinRate(currentGameInfo);
	}


}
