package org.aiwolf.MayQueen;

import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinationContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.IdentContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MyMedium extends MyBasePlayer {
	int comingoutDay;
	boolean isCameout;
	Deque<Judge> identQueue = new LinkedList<>();
	Map<Agent, Species> myIdentMap = new HashMap<>();
	int before = -1;
	int talkturn = 0;/** 延々と投票先を発言する*/

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);// 基底クラスの処理を実⾏
		comingoutDay = (int) (Math.random() * 3 + 1);
		isCameout = false;
		identQueue.clear();
		myIdentMap.clear();
	}

	@Override
	public void update(GameInfo gameInfo) {
		// TODO 自動生成されたメソッド・スタブ
		super.update(gameInfo);
		minSort();//疑い度を小さい順にする
	}

	@Override
	public void dayStart() {
		super.dayStart();// 基底クラスの処理を実⾏

		/** 霊媒結果を待ち行列に入れる*/
		Judge ident = currentGameInfo.getMediumResult();
		if (ident != null) {
			identQueue.offer(ident);
			myIdentMap.put(ident.getTarget(), ident.getResult());
		}
	}




	@Override
	protected Agent chooseVote() {
		werewolves.clear();
		// 霊媒師をカミングアウトしている他のエージェントは人狼候補
		for (Agent agent : aliveOthers) {
			if (comingoutMap.get(agent) == Role.MEDIUM) {
				werewolves.add(agent);
			}
		}
		// 自分や殺されたエージェントを人狼と判定，あるいは自分と異なる判定の占い師は人狼候補
		for (Judge j : divinationList) {
			Agent agent = j.getAgent();
			Agent target = j.getTarget();
			if (j.getResult() == Species.WEREWOLF && (target == me || isKilled(target)) || (myIdentMap.containsKey(target) && j.getResult() != myIdentMap.get(target))) {
				if (isAlive(agent) && !werewolves.contains(agent)) {
					werewolves.add(agent);
				}
			}
		}
		//候補がいない場合は疑い度に沿って決める
		if (werewolves.isEmpty() && minsortDoubtList.size() != 0) {
			werewolves.add(minsortDoubtList.get(0));
			//System.out.println(minsortDoubtList);
		}
		// 候補がいない場合はランダム
		if (werewolves.isEmpty()) {
			if (!aliveOthers.contains(voteCandidate)) {
				voteCandidate = randomSelect(aliveOthers);
			}
		} else {
			if (!werewolves.contains(voteCandidate)) {
				voteCandidate = randomSelect(werewolves);
				// 以前の投票先から変わる場合，新たに推測発言と占い要請をする
				if (canTalk) {
					talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
					talkQueue.offer(new Content(new RequestContentBuilder(null, new Content(new DivinationContentBuilder(voteCandidate)))));
				}
			}
		}
		return voteCandidate;
	}


	@Override
	public String chooseTalk() {
		boolean doco = false;/** カミングアウトをおこなったか*/
		boolean dovote = false;/** 投票内容を決めたか*/

		// カミングアウトする日になったら，あるいは霊媒結果が人狼だったら,あるいは霊媒師カミングアウトが出たらカミングアウト
		if (!isCameout && (day >= comingoutDay || (!identQueue.isEmpty() && identQueue.peekLast().getResult() == Species.WEREWOLF) || isCo(Role.MEDIUM))) {
			isCameout = true;
			return (new Content(new ComingoutContentBuilder(me, Role.MEDIUM))).getText();
		}

		// カミングアウトしたらこれまでの霊媒結果をすべて公開
		if (isCameout && !doco) {
			doco = true;
			while (!identQueue.isEmpty()) {
				Judge ident = identQueue.poll();
				return (new Content(new IdentContentBuilder(ident.getTarget(), ident.getResult()))).getText();
			}
		}

		if (!dovote) {
			dovote = true;
			return (new Content(new VoteContentBuilder(chooseVote()))).getText();
		}

		talkturn++;/**延々と投票先を発言する*/

		if (talkturn > 1 && talkQueue.isEmpty() && vote() != null) { // 発⾔キューが空なら

			return (new Content(new VoteContentBuilder(vote()))).getText();
		}

		return Talk.SKIP;
//		return super.talk();
	}
	@Override
	void parseSentence(Content content) {
		switch(content.getTopic()) { // Topicで処理を分ける
		case COMINGOUT: // カミングアウト
			/*comingoutMap.put(content.getTarget(), content.getRole()); // COマップに追加
			noCodivined.remove(content.getTarget());//COしていないリストから削除
			if(voteCandidate==content.getTarget()) {//すでに投票相手にしたプレイヤがCOした場合投票対象を初期化する
				voteCandidate=null;
			}*/
			return;
		case DIVINED: // 占い結果
			// 占い結果リストに追加
			divinationList.add(new Judge(day, content.getSubject(), content.getTarget(), content.getResult()));
			//noCodivined.remove(content.getTarget());//占われていないリストから削除
			//黒判定エージェントリストに追加
			if(content.getResult() == Species.WEREWOLF) {
				if(blackDivineList.contains(content.getTarget()) && !BlackList.contains(content.getTarget())){//黒判定を受けたエージェントがすでに黒判定を受けている場合(まだリストに追加されていない)
					DoubtAddRemove(content.getTarget());
				}
				blackDivineList.add(content.getTarget());
				Doubt(content.getTarget(),-1);//黒判定を受けたプレイヤの疑い度-1
			}
			//白判定エージェントリストに追加
			if(content.getResult() == Species.HUMAN) {
				whiteDivineList.add(content.getTarget());
				Doubt(content.getTarget(), 1);//白判定を受けたプレイヤの疑い度+1
			}
			if(BlackList.contains(content.getTarget()) && content.getResult()==Species.HUMAN) {//BlackListのエージェントを人間判定した場合
				DoubtAddRemove(content.getSubject());//BlackListに追加
			}
			return;
		case IDENTIFIED: // 霊媒結果
			//identList.add(new Judge(day, content.getSubject(), content.getTarget(), content.getResult()));
			return;
		case VOTE:
			return;
		case ESTIMATE:
			return;
		case OPERATOR: // 演算⼦
			parseOperator(content); // 演算⼦解析に渡す
			return;
		default:
			break;
		}
	}

	@Override
	void parseOperator(Content content) {
		switch(content.getOperator()) { // Operatorで処理を分ける
		case BECAUSE: //because(理由)
			parseSentence(content.getContentList().get(1)); // 理由は無視して，結果のみ解析
			break;
			/*case DAY: //day(⽇付)
		 parseSentence(content.getContentList().get(0)); // 内容のみ再解析
		 break;*/
		case AND: /*and(全てがtrue)*/ case OR: /*or(どれかがtrue)*/ case XOR: /*xor(どちらかがtrue)*/
			for(Content c : content.getContentList()) { // 全ての⽂を分割して再解析
				parseSentence(c);
			}
			break;
		case REQUEST: /*request(要求)*/
			//System.out.println("REQUEST/////"+content.getSubject()+":"+DoubtMap.get(content.getSubject()));
			//if(DoubtMap.containsKey(content.getSubject()) && DoubtMap.get(content.getSubject())>=70) {//信頼度が70以上の場合リクエストに応じる
			//	parseRequest(content.getContentList().get(0));//内容をリクエスト用で解析する
			//}
			break;
		case INQUIRE: /*inquire(状態を聞く)*/
			break; // 省略
		default:
			break;
		}
	}

}