//提出用占いエージェント

package org.aiwolf.MayQueen;

import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MySeer extends MyBasePlayer {
	int comingoutDay;
	int numAgents;
	int numseers;
	int firstnumAgents;
	/**カミングアウトの日を決める？*/
	boolean isCo; // カミングアウトをしたかどうか
	Deque<Judge> divinationQueue = new LinkedList<>();
	/**占いキュー？*/
	Map<Agent, Species> myDivinationMap = new HashMap<>();
	/**占い先マップ？*/
	List<Agent> whiteList = new ArrayList<>();//占った結果白のエージェント
	List<Agent> blackList = new ArrayList<>(); // 占った結果⿊のエージェント
	List<Agent> grayList = new ArrayList<>(); // 占っていない⽣存エージェント
	List<Agent> candidates = new ArrayList<>();//占っていないエージェントリスト
	List<Agent> semiWolves = new ArrayList<>();
	/**人狼候補リスト？*/
	List<Agent> possessedList = new ArrayList<>();



	Map<Agent, Species> fakeJudgeMap = new HashMap<>();// 偽占いマップ
	Judge fakeJudge;//偽の占い結果
	Deque<Judge> fakeJudgeQueue = new LinkedList<>();//未公表偽占いの待ち行列

	/**延々と投票先を発言する**/
	int talkturn = 0;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting); // 基底クラスの処理を実⾏

		comingoutDay = (int) (Math.random() * 3 + 1);/**カミングアウト日を設定*/
		numseers = 0;
		firstnumAgents = 0;
		isCo = false; // カミングアウト状況を初期化(=false)
		divinationQueue.clear();/**占いキュー？を初期化*/
		myDivinationMap.clear();/**占い先マップ？を初期化*/
		fakeJudgeMap.clear();//偽占いマップを初期化
		fakeJudgeQueue.clear();//未公表偽占いの待ち行列を初期化
		possessedList.clear();//狂人リストを初期化
		whiteList.clear();//白エージェントリストを初期化
		blackList.clear(); // ⿊エージェントリストを初期化
		candidates.clear();//初期化
		grayList = currentGameInfo.getAliveAgentList(); // 未占い⽣存エージェントを取得
		grayList.remove(me); // ⾃分を未占い⽣存エージェントから削除
		semiWolves.clear();/**ほぼ人狼リスト？を初期化*/
		possessedList.clear();/**人狼候補なのに人間（狂人）のリスト？を初期化*/

	}

	@Override
	public void dayStart() {
		super.dayStart(); // 基底クラスの処理を実⾏
		numAgents = currentGameInfo.getAliveAgentList().size();
		Judge dResult = currentGameInfo.getDivineResult(); // 占い結果を取得
		fakeJudgeMap.put(me,Species.HUMAN);//自分を占い済みにして占い対象から除外
		numseers = 0;
		if(day == 2) {
			for (Agent a : Others) {
				if (comingoutMap.get(a) == Role.SEER) {
					//自分以外が占い師をカミングアウトしている場合＝偽占い師である
					numseers++;
				}

			}
		}

		if (day == 1 && !isCo) { // 初⽇に未カミングアウト状態なら
			// カミングアウト発⾔をtalkQueueに⼊れる
			talkQueue.offerLast(new Content(new ComingoutContentBuilder(me, me, Role.SEER)));
			isCo = true; // カミングアウトしたのでフラグを切り替える
		}
		if(numAgents==5&&day ==1) {
			firstnumAgents = 5;
			if (dResult != null) { // 結果があれば(0⽇⽬などは，結果がない場合があるので)
				grayList.remove(dResult.getTarget()); // 占ったのでgrayListからは削除
				fakeJudgeMap.put(dResult.getTarget(),dResult.getResult());

				if (dResult.getResult() == Species.WEREWOLF) {
					//占い結果が⼈狼なら
					if (blackList.contains(dResult.getTarget())) {
						blackList.add(dResult.getTarget()); // blackList未追加なら追加
					}
					talkQueue.offerLast(new Content(new DivinedResultContentBuilder( // 占い結果発⾔をtalkQueueに追加
							me, dResult.getTarget(), dResult.getResult())));
				} else {
					//占い結果が人間なら
					Judge judge = FakeDivination();//偽占いをする
					if (judge != null) {
						fakeJudgeQueue.offer(judge);/**未公表偽占いの待ち行列に情報を入れる？*/
						fakeJudgeMap.put(judge.getTarget(), judge.getResult());/**偽占いマップに情報を入れる？*/
					}

					if (whiteList.contains(dResult.getTarget())) {
						whiteList.add(dResult.getTarget()); // whiteList未追加なら追加
					}
					talkQueue.offerLast(new Content(new DivinedResultContentBuilder( // 占い結果発⾔をtalkQueueに追加
							me, judge.getTarget(), judge.getResult())));
				}
			}
		}else if(firstnumAgents==5&&numAgents==3&&numseers==2){
			//偽COしない
			if (dResult != null) { // 結果があれば(0⽇⽬などは，結果がない場合があるので)
				grayList.remove(dResult.getTarget()); // 占ったのでgrayListからは削除

				if (dResult.getResult() == Species.WEREWOLF) {
					//占い結果が⼈狼なら
					if (blackList.contains(dResult.getTarget())) {
						blackList.add(dResult.getTarget()); // blackList未追加なら追加
					}
				} else {
					//占い結果が人間なら
					if (whiteList.contains(dResult.getTarget())) {
						whiteList.add(dResult.getTarget()); // whiteList未追加なら追加
					}
				}

				talkQueue.offerLast(new Content(new DivinedResultContentBuilder( // 占い結果発⾔をtalkQueueに追加
						me, dResult.getTarget(), dResult.getResult())));
			}
		}else if(numAgents==3){
				talkQueue.offerLast(new Content(new ComingoutContentBuilder(me, me, Role.POSSESSED)));//PP妨害
		}else {
			if (dResult != null) { // 結果があれば(0⽇⽬などは，結果がない場合があるので)
				grayList.remove(dResult.getTarget()); // 占ったのでgrayListからは削除

				if (dResult.getResult() == Species.WEREWOLF) {
					//占い結果が⼈狼なら
					if (blackList.contains(dResult.getTarget())) {
						blackList.add(dResult.getTarget()); // blackList未追加なら追加
					}
				} else {
					//占い結果が人間なら
					if (whiteList.contains(dResult.getTarget())) {
						whiteList.add(dResult.getTarget()); // whiteList未追加なら追加
					}
				}

				talkQueue.offerLast(new Content(new DivinedResultContentBuilder( // 占い結果発⾔をtalkQueueに追加
						me, dResult.getTarget(), dResult.getResult())));
			}
		}
	}


	protected void init() {
	}


	@Override
	public Agent chooseVote() {
		if(day == 1){
		// blackListに⽣存エージェントがいれば投票
		if (!blackList.isEmpty()) {
			for (Agent agent : blackList) {
				if (isAlive(agent)) {
					return agent;
				}
			}
		}

		// 確定人狼がいない場合は推測する
		werewolves.clear();//人狼側リスト

		// 偽占い師
		for (Agent a : aliveOthers) {
			if (comingoutMap.get(a) == Role.SEER) {
				//自分以外が占い師をカミングアウトしている場合＝偽占い師である
				werewolves.add(a);//人狼側リストに追加
			}
		}

		possessedList.clear();
		semiWolves.clear();

		for (Agent a : werewolves) {
			// 人狼側のエージェントを抽出
			if (whiteList.contains(a)) {
				// 人狼側のエージェントなのにホワイトリストに入っている（人間）→裏切り者
				if (!possessedList.contains(a)) {
					talkQueue.offer(new Content(new EstimateContentBuilder(a, Role.POSSESSED)));
					possessedList.add(a);
				}
			} else {
				// 人狼側のエージェントでホワイトリストに入っていない→人狼候補
				semiWolves.add(a);//人狼候補リストに追加
			}
		}

		if (!semiWolves.isEmpty()) {
			//ほぼ人狼リストにエージェントがいればそいつに投票
			if (!semiWolves.contains(voteCandidate)) {
				voteCandidate = randomSelect(semiWolves);
				// 以前の投票先から変わる場合，新たに推測発言をする
				if (canTalk) {
					talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
				}
				return randomSelect(semiWolves);
			}
		} else {

			if (!grayList.isEmpty()) {
				// grayListにエージェントがいればランダム投票
				return randomSelect(grayList);
			}
		}

		return randomSelect(aliveOthers); // 最終⼿段として⽣存エージェントからランダム

		}else {
			// blackListに⽣存エージェントがいれば投票
			if (!blackList.isEmpty()) {
				for (Agent agent : blackList) {
					if (isAlive(agent)) {
						return agent;
					}
				}
			}

			// 確定人狼がいない場合は推測する
			werewolves.clear();//人狼側リスト

			// 偽占い師
			for (Agent a : aliveOthers) {
				if (comingoutMap.get(a) == Role.SEER) {
					//自分以外が占い師をカミングアウトしている場合＝偽占い師である
					werewolves.add(a);//人狼側リストに追加
				}
			}

			possessedList.clear();
			semiWolves.clear();

			for (Agent a : werewolves) {
				// 人狼側のエージェントを抽出
				if (whiteList.contains(a)) {
					// 人狼側のエージェントなのにホワイトリストに入っている（人間）→裏切り者
					if (!possessedList.contains(a)) {
						talkQueue.offer(new Content(new EstimateContentBuilder(a, Role.POSSESSED)));
						possessedList.add(a);
					}
				} else {
					// 人狼側のエージェントでホワイトリストに入っていない→人狼候補
					semiWolves.add(a);//人狼候補リストに追加
				}
			}

			if (!semiWolves.isEmpty()) {
				//ほぼ人狼リストにエージェントがいればそいつに投票
				if (!semiWolves.contains(voteCandidate)) {
					voteCandidate = randomSelect(semiWolves);
					// 以前の投票先から変わる場合，新たに推測発言をする
					if (canTalk) {
						talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
					}
					return randomSelect(semiWolves);
				}
			} else {

				if (!grayList.isEmpty()) {
					// grayListにエージェントがいればランダム投票
					return randomSelect(grayList);
				}
			}

			return randomSelect(aliveOthers); // 最終⼿段として⽣存エージェントからランダム

		}
	}


	@Override
	public String chooseTalk() {

		talkturn++;/** 延々と投票先を発言する*/

		if (talkturn > 1 && talkQueue.isEmpty()) { // 発⾔キューが空なら
			return (new Content(new VoteContentBuilder(vote()))).getText();
		}

		return Talk.SKIP;
//		return super.talk();
	}



	@Override
	public Agent divine() {

		if (!semiWolves.isEmpty()) {// 人狼候補がいればそれらからランダムに占う
			return randomSelect(semiWolves);
		}

		if (grayList.isEmpty()) { // grayListが空なら
			return randomSelect(aliveOthers); // ⽣存エージェントからランダムに占う
		}

		return randomSelect(grayList); // グレーの中からランダムに占う
	}


	public Judge FakeDivination() {
		//占い対象を選択し，そのプレイヤに偽の判定を出す

		Agent target = null;//偽占い対象
		for (Agent a : aliveOthers) {
			//まだ占っていない（占うふりをしていない）かつ　占い師以外を占いたいのでリストに格納
			if (!me.equals(a)&&!fakeJudgeMap.containsKey(a) && comingoutMap.get(a) != Role.SEER) {
				candidates.add(a);
			}
		}
		if (candidates.isEmpty()) {
			//占っていないエージェントリストが空の場合（ほとんどない）
			target = randomSelect(aliveOthers);//生きているエージェントからランダムに
			} else {
			//占っていないエージェントリストから偽占い対象を選ぶ
			target = randomSelect(candidates);
		}

		if (target != null) {
			Species result = Species.WEREWOLF;

			// 人間が偽占い対象の場合
			if (humans.contains(target)) {
					//人狼判定
					result = Species.WEREWOLF;
			}
			return new Judge(day, me, target, result);//判定を返す
		}

		return new Judge(day, me, randomSelect(aliveOthers), Species.WEREWOLF);//ターゲットがいない場合（通常ない）
	}
}
