package org.aiwolf.MayQueen;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.client.lib.AgreeContentBuilder;
import org.aiwolf.client.lib.AttackContentBuilder;
import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.TalkType;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MyWerewolf extends MyBasePlayer {

	Role fakeRole;//騙る役職

	int comingoutDay;//カミングアウトする日

	int comingoutTurn;

	int talkTurn;

	int count;

	int readWhisperIdx;

	boolean isCo;//カミングアウトしたかどうか

	boolean ppco;

	boolean start;

	boolean five;

	int talkturn = 0;/** 延々と投票先を発言する*/

	Agent sameAttack;

	Map<Agent, Species> fakeJudgeMap = new HashMap<>();// 偽占いマップ
	Judge fakeJudge;//偽の占い結果

	Deque<Judge> fakeJudgeQueue = new LinkedList<>();//未公表偽占いの待ち行列

	List<Agent> possessedList = new ArrayList<>();//狂人リスト

	List<Agent> humans;//人間リスト（狂人込み）

	List<Agent> villagers = new ArrayList<>();//村人リスト

	//以下研究用に変更した部分
	/** whisperListの読み込みヘッド*/
	int whisperListHead;

	Talk whispertalk;

	/** 人狼がどの役職を騙りするか */
	Map<Agent,Role> werewolfRole = new HashMap<Agent, Role>();

	/** 囁き用待ちリスト */
	private Deque<Content> whisperQueue = new LinkedList<>();
	/** 囁きの内容 */
	List<Talk> whisperList = new ArrayList<>();
	/** 狂人を見つけたか */
	boolean findpossed;
	/** 生きている村人陣営のリスト*/
	List<Agent> alivehuman;
	/** 生きている人狼陣営のリスト*/
	List<Agent> ww;

	/** 生きている人狼陣営のリスト*/
	List<Agent> mostwinw;
	/** Talkかwhisperかを判断する */
	boolean talktime;

	/** COのREQUESTをうけたか */
	boolean isComingoutRequest;
	/** 騙る役職を宣言したか */
	boolean isFakeComingout;
	/** 襲撃するプレイヤのリスト */
	List<Agent> attackList= new ArrayList<Agent>();
	boolean isAttackRequest;
	/** 占い結果を報告したか*/
	boolean isDivination;
	/** 襲撃先を宣言したか*/
	boolean isAttackVote;





	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);// 基底クラスの処理を実⾏

		talkTurn = -1;
		alivehuman = new ArrayList<>();
		ww = new ArrayList<>();
		mostwinw = new ArrayList<>();
		for (Agent a : aliveOthers) {
			if (!werewolves.contains(a)) {
				alivehuman.add(a);//人狼ではないプレイヤを人間リストに入れる
			}
		}

		//人狼である自分以外（＝村人占い師狂人）を格納する人間リストを作成
		humans = new ArrayList<>();
		for (Agent a : aliveOthers) {
			if (!werewolves.contains(a)) {
				humans.add(a);
			}
		}

		//騙る役職を村人と占い師からランダムに決める
		List<Role> roles = new ArrayList<>();
		for (Role r : Arrays.asList(Role.VILLAGER, Role.SEER)) {
			if (gameInfo.getExistingRoles().contains(r)) {
				roles.add(r);//役職：占い師と村人のみが格納されたリスト
			}
		}
		fakeRole = randomSelect(roles);//村人と占い師のどちらかが選ばれる

		comingoutDay = (1);//1日目にカミングアウトする
		comingoutTurn = (0);// 第0ターンにカミングアウトする
		//comingoutTurn = (int) (Math.random() * 5);// 第0～4ターンからランダムにカミングアウトする

		isCo = false;//カミングアウトを初期化
		ppco=false;
		fakeJudgeMap.clear();//偽占いマップを初期化
		fakeJudgeQueue.clear();//未公表偽占いの待ち行列を初期化
		possessedList.clear();//狂人リストを初期化
		werewolfRole.clear();//人狼の騙り役職を初期化
		}

	@Override
	public void dayStart() {
		super.dayStart();// 基底クラスの処理を実⾏
		attackList.clear();//襲撃リストを初期化
		isComingoutRequest=false;
		isFakeComingout=false;
		whisperListHead=0;
		talktime=true;

		isAttackRequest=false;
		isDivination=false;
		isAttackVote=false;
		//isVoteRequest=false;
		mostwinw = WinRateCalc.getMostWinners(ww);


		if (day == 0) {
			if(aliveOthers.size()==4) {
				five=true;

			}else {
				five=false;
				}
			whisperQueue.offer(new Content(new ComingoutContentBuilder(me, fakeRole)));
		} else {
			// 偽の判定
			Judge judge = FakeDivination();
			if (judge != null) {
				fakeJudgeQueue.offer(judge);/**未公表偽占いの待ち行列に情報を入れる？*/
				fakeJudgeMap.put(judge.getTarget(), judge.getResult());/**偽占いマップに情報を入れる？*/
			}
		}
		fakeJudge = null;//初期化
		whisperList.clear();
		sameAttack = null;
		AttackVoteCandidate=null;
		whisperQueue.clear();
	}

	@Override
	public void update(GameInfo gameInfo) {
		super.update(gameInfo);// 基底クラスの処理を実⾏
		minSort();//信頼度を小さい順にする
		//List<Talk> whisperList = gameInfo.getWhisperList();
		currentGameInfo = gameInfo; // currentGameInfoの更新
		Agent executedAgent = currentGameInfo.getLatestExecutedAgent(); // 追放エージェント取得
		if(executedAgent != null) { // 追放エージェントがnullでなければ
			alivehuman.remove(executedAgent); // ⽣存エージェントリストから削除
		}
		//whisperの処理-----------------------------------------------------------------------------------------------------------
				for(int i = whisperListHead; i < currentGameInfo.getWhisperList().size(); i++) { // 前回までに読んだ場所の次から解析
					whispertalk = currentGameInfo.getWhisperList().get(i); // i番⽬のトーク取得
					Agent talker = whispertalk.getAgent(); // 発話者を取得
					if(!ww.contains(talker)) {
						ww.add(talker);
					}

					Content content = new Content(whispertalk.getText()); // Content型に変換
					if(content.getSubject()==Content.UNSPEC) { // 主語が省略されている場合
						if(content.getTopic() != Topic.SKIP && content.getTopic() != Topic.OVER) { // SKIPでもOVERでもなければ
							content = new Content(talker + " " + Content.stripSubject(content.getText())); // 主語を発話者に置き換える
						}
					}
					Topic topic = content.getTopic();//会話内のトピック

					switch(topic) {
					case ATTACK:
						//発話者に合わせるために格納
						if(mostwinw.contains(talker)) {
							sameAttack = content.getTarget();
							}


						break;

					case COMINGOUT:
						//発言者と自分のCOする役職が同じの場合自分のCOする役職を変更する
						if(this.day==0 && talker!=me) {
							werewolfRole.put(talker,content.getRole());//人狼の騙り役職を格納

						}
						break;
					case OPERATOR:
						if(content.getSubject()!=me) {
							parseOperator(content);
						}
						break;


					case SKIP:

						break;
					default:
						break;
					}
					whisperListHead = currentGameInfo.getWhisperList().size(); // talkListHeadを今のリストのサイズに置き換えておく(次回の読み始め位置)

				}

		// 占い結果が嘘の場合，裏切り者(=狂人)なので狂人リストに格納
		for (Judge j : divinationList) {
			Agent agent = j.getAgent();
			if (!werewolves.contains(agent) && ((humans.contains(j.getTarget()) && j.getResult() == Species.WEREWOLF)
					|| (werewolves.contains(j.getTarget()) && j.getResult() == Species.HUMAN))) {
				//自分以外に人狼判定を出している，または自分に人間判定を出している場合
				if (!possessedList.contains(agent)) {
					possessedList.add(agent);//狂人リストに格納
					//whisperQueue.offer(new Content(new EstimateContentBuilder(agent, Role.POSSESSED)));
				}
			}
		}

		//村人リストを作成
		villagers.clear();
		for (Agent agent : aliveOthers) {
			//生きていて狂人リストにいないエージェントはただの村人
			if (!werewolves.contains(agent) && !possessedList.contains(agent)) {
				villagers.add(agent);//村人リストに追加
			}
		}
	}
	@Override
	public String whisper(){
		new ArrayList<>();
		talktime=false;
		Double fakeramdom=Math.random();
		if(this.day==0) {
			if(!isFakeComingout) {
				if(fakeramdom<0.5) {
					this.fakeRole=Role.VILLAGER;
				}else if (fakeramdom>0.95){
					this.fakeRole=Role.MEDIUM;
				}else {
					this.fakeRole=Role.SEER;
				}
				whisperQueue.offer(new Content(new ComingoutContentBuilder(this.me,this.fakeRole)));
				isFakeComingout=true;
			}
			if(whisperQueue.isEmpty() && !werewolfRole.containsValue(Role.SEER) && fakeRole!=Role.SEER)  {//誰も占い師騙りをしない場合
				whisperComingoutRequest(Content.ANY, Role.SEER);
			}
			//霊媒師か占い師騙りが被っていた場合
			if(whisperQueue.isEmpty() && werewolfRole.containsValue(fakeRole) && (fakeRole==Role.SEER || fakeRole==Role.MEDIUM) ) {
				fakeRole=Role.VILLAGER;
				whisperQueue.offer(new Content(new ComingoutContentBuilder(this.me,this.fakeRole)));
			}

		}
		//襲撃対象の選択と襲撃対象のREQUEST---------------------------------------------------------------------------
		//AttackVote();
		//-----------------------------------------------------------------------------------------------------------------

		if(!attackList.isEmpty()){//襲撃対象がいてなおかつまだ宣言していない時
			if(!isAttackVote) {
				//襲撃リストからランダムに選択し襲撃対象にする
				AttackVoteCandidate=randomSelect(attackList);
				whisperQueue.offer(new Content(new AttackContentBuilder(AttackVoteCandidate)));
				isAttackVote=true;
			}
			if(day>=4 && whisperQueue.isEmpty() && !isAttackRequest) {//リクエストを受けていない場合
				AttackRequest(null, AttackVoteCandidate);//襲撃対象のREQUESTをする

			}
		}

		if (whisperQueue.isEmpty()) {
			return "Skip";
		} else {
			Content content = whisperQueue.poll();
			return content.getText() ;
		}
	}


	public Judge FakeDivination() {
		//占い対象を選択し，そのプレイヤに偽の判定を出す

		Agent target = null;//偽占い対象

		// 占い師騙りの場合
		if (fakeRole == Role.SEER) {
			List<Agent> candidates = new ArrayList<>();//占っていないエージェントリスト
			for (Agent a : aliveOthers) {
				//まだ占っていない（占うふりをしていない）かつ　占い師以外を占いたいのでリストに格納
				if (!fakeJudgeMap.containsKey(a) && comingoutMap.get(a) != Role.SEER) {
					candidates.add(a);
				}
			}

			if (candidates.isEmpty()) {
				//占っていないエージェントリストが空の場合（ほとんどない）
				target = randomSelect(aliveOthers);//生きているエージェントからランダムに
			} else {
				//占っていないエージェントリストから偽占い対象を選ぶ
				target = randomSelect(candidates);
			}
		}

		if (target != null) {
			Species result = Species.HUMAN;

			// 人間が偽占い対象の場合
			if (humans.contains(target)) {
				if (possessedList.contains(target)) {
					// 裏切り者エージェントの場合，判定は五分五分
					if (Math.random() < 0.5) {
						result = Species.WEREWOLF;
					}
				} else {
					// それ以外は人狼判定
					result = Species.WEREWOLF;
				}
			}
			return new Judge(day, me, target, result);//判定を返す
		}

		return new Judge(day, me, randomSelect(aliveOthers), Species.WEREWOLF);//ターゲットがいない場合（通常ない）
	}


	@Override
	public Agent chooseVote() {
		List<Agent> candidates = new ArrayList<>();//投票先候補リスト
		Agent voteAgents = null;//投票先
		if(ppco) {
			for (Agent a : aliveOthers) {
				//狂人，人狼COしてなければ投票リストに入れる
				if (comingoutMap.get(a) != Role.POSSESSED||comingoutMap.get(a) != Role.WEREWOLF) {
					candidates.add(a);
				}
			}
			if (candidates.isEmpty()) {
				for (Agent a : aliveOthers) {
						candidates.add(a);
				}
			}
		}else {
		// 占い師騙りの場合
			if (fakeRole != Role.VILLAGER) {
				// 人狼と偽判定した村人陣営は投票先最有力候補
				for (Agent a : villagers) {
					if (fakeJudgeMap.get(a) == Species.WEREWOLF) {
						candidates.add(a);
					}
				}

				// 候補がいなければ対抗カミングアウトした占い師かつ狂人ではないエージェントから
				if (candidates.isEmpty()) {
					for (Agent a : villagers) {
						if (comingoutMap.get(a) == fakeRole && !possessedList.contains(a)) {
							candidates.add(a);
						}
					}
				}

			// 候補がいなければ人間と判定していない村人陣営から
				if (candidates.isEmpty()) {
					for (Agent a : villagers) {
						if (fakeJudgeMap.get(a) != Species.HUMAN) {
						candidates.add(a);
						}
					}
				}

			}

			// 村人騙り，あるいは候補がいない場合ば村人陣営から
			for (Judge j : divinationList) {
				// 自分を人狼と判定していて，生存している自称占い師を投票先候補とする
				if (j.getResult() == Species.WEREWOLF && j.getTarget() == me) {
					Agent candidate = j.getAgent();
					if (isAlive(candidate) && !werewolves.contains(candidate)) {
						candidates.add(candidate);
					}
				}
			}

			//候補がいない場合は疑い度に沿って決める
			if (candidates.isEmpty() && minsortDoubtList.size() != 0) {
				candidates.add(minsortDoubtList.get(0));
				//System.out.println(minsortDoubtList);
			}
			if (candidates.isEmpty()) {
				candidates.addAll(villagers);
			}

			// それでも候補がいない場合は狂人に投票
			if (candidates.isEmpty()) {
				candidates.addAll(possessedList);
			}

			if (!candidates.isEmpty()) {
				if (!candidates.contains(voteCandidate)) {
					//投票先候補リストからランダムに投票先を決定
					voteAgents = randomSelect(candidates);

					if (canTalk) {
						//話せるなら投票先が人狼だと話す
						talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
					}
				}
			}
		}

		return voteAgents;
	}

	@Override
	public String chooseTalk() {
		talkTurn++;
		if (voteCandidate == null) {//投票先候補いない場合
			voteCandidate = randomSelect(aliveOthers);
			return (new Content(new VoteContentBuilder(voteCandidate))).getText();//生きているプレイヤの中からランダムに選択し，そのプレイヤに投票することを宣言
		}

		if (fakeRole != Role.VILLAGER) {
			if (!isCo) {
				// 対抗カミングアウトがある場合，今日カミングアウトする
				for (Agent a : humans) {
					if (comingoutMap.get(a) == fakeRole&&!ppco) {
						comingoutDay = day;
					}
				}

				// カミングアウトするタイミングになったらカミングアウト
				if (day >= comingoutDay && talkTurn >= comingoutTurn&&!ppco) {
					isCo = true;
					return (new Content(new ComingoutContentBuilder(me, fakeRole))).getText();
				}
			} else if(!ppco){
				// カミングアウトしたらこれまでの偽判定結果をすべて公開
				while (!fakeJudgeQueue.isEmpty()) {
					Judge judge = fakeJudgeQueue.poll();
					if (fakeRole == Role.SEER&&!ppco) {
						return (new Content(new DivinedResultContentBuilder(judge.getTarget(), judge.getResult()))).getText();
					}
				}
			}
		}
		for (Agent agent : aliveOthers) {
			if (comingoutMap.get(agent) == Role.POSSESSED&&!ppco) {
				isCo = true;
				ppco = true;
				fakeRole = Role.WEREWOLF;
				return (new Content(new ComingoutContentBuilder(me, Role.WEREWOLF))).getText();
			}
		}

		talkturn++;/**延々と投票先を発言する*/

		if (talkturn > 1 && talkQueue.isEmpty() && vote() != null) { // 発⾔キューが空なら

			return (new Content(new VoteContentBuilder(vote()))).getText();
		}

		return Talk.SKIP;
//		return super.talk();
	}

	@Override
	public Agent attackVote() {
		List<Agent> candidates = new ArrayList<>();//襲撃先候補リスト
		Agent attackAgent = null;//襲撃先

		//sameAttack = null;

		if(five) {
			for (Agent a : aliveOthers) {
				// カミングアウトした占い師は最有力襲撃先候補(
				if (comingoutMap.get(a) == Role.SEER) {
					candidates.add(a);
				}
			}
			if(candidates.size()==2&&fakeRole==Role.VILLAGER) {
				candidates.clear();
			}
			if(candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				// カミングアウトした占い師は襲撃候補ではない(狂人と分かっている場合は除く)
				if (comingoutMap.get(a) != Role.SEER) {
					candidates.add(a);
				}
			}
			}


			// 占い師がいなければ村人と分かっているエージェントから
			if (candidates.isEmpty()) {
				candidates.addAll(villagers);//村人を襲撃先候補リストに追加
			}

			// 村人もいない場合は狂人を襲う
			if (candidates.isEmpty()) {
				candidates.addAll(possessedList);//狂人を襲撃先候補リストに追加
			}

			if (!candidates.isEmpty()) {
				//襲撃先候補リストからランダムに襲撃先を決定
				attackAgent = randomSelect(candidates);
			} else {
				//襲撃先候補リストが空ならnullを返す（通常ない）
				attackAgent = null;
			}
		}else {

		if(sameAttack != null) {
			candidates.add(sameAttack);
		}else {
			for (Agent a : aliveOthers) {
				// カミングアウトした占い師は最有力襲撃先候補(狂人と分かっている場合は除く)
				if (comingoutMap.get(a) == Role.SEER && !possessedList.contains(a)) {
					candidates.add(a);
				}
			}
		}

		// 占い師がいなければ村人と分かっているエージェントから
		if (candidates.isEmpty()) {
			candidates.addAll(villagers);//村人を襲撃先候補リストに追加
		}

		// 村人もいない場合は狂人を襲う
		if (candidates.isEmpty()) {
			candidates.addAll(possessedList);//狂人を襲撃先候補リストに追加
		}

		if (!candidates.isEmpty()) {
			//襲撃先候補リストからランダムに襲撃先を決定
			attackAgent = randomSelect(candidates);
		} else {
			//襲撃先候補リストが空ならnullを返す（通常ない）
			attackAgent = null;
		}
		}
		return attackAgent;
	}

	void whisperAgreeContent() {
		whisperQueue.offer(new Content(new AgreeContentBuilder(TalkType.TALK,whispertalk.getDay(),whispertalk.getIdx())));
	}

	/**
	 *  whisperでのREQUEST発言をする
	 * @param target REQUESTを送る相手
	 * @param content REQUESTの内容
	 */
	void whisperRequest(Agent target ,Content content) {
		whisperQueue.offer(new Content(new RequestContentBuilder(target, content)));

	}
	/**
	 * whisperでのCOのREQUESUT
	 * @param target REQUES送る相手
	 * @param role COしてほしい役職
	 */
	void whisperComingoutRequest(Agent target,Role role) {
		if(!isComingoutRequest) {//REQUESTを受けていない場合
			whisperRequest(target, new Content(new ComingoutContentBuilder(target, role)));
			isComingoutRequest=true;
		}
	}
	/**
	 * 襲撃のREQUEST
	 * @param target REQUESTを送る相手
	 * @param attacktarget 襲撃対象
	 */
	void AttackRequest(Agent target,Agent attacktarget) {
		if(!isAttackRequest && attacktarget!=null) {//REQUESTを受けていない時
			whisperRequest(target, new Content(new AttackContentBuilder(attacktarget)));
			isAttackRequest=true;
		}

	}
	/**
	 * 白判定を受けたプレイヤを襲撃対象にする
	 * @param target 生きている村人
	 */
	void attackWhiteList (List<Agent> target) {
		if(attackList.isEmpty()) {//襲撃対象がいない場合
			for(Agent agent:target) {
				if(whiteDivineList.contains(agent) && !comingoutMap.containsKey(agent)) {//白判定を受けていてまだCOしていない場合
					attackList.add(agent);
				}
			}
		}
	}
	/**
	 * COしていないプレイヤを襲撃対象にする
	 * @param target 生きている村人
	 */
	void attacknoComing(List<Agent> target) {
		if(attackList.isEmpty()) {//襲撃対象がいない場合
			for(Agent agent:target) {
				if(!comingoutMap.containsKey(agent)) {//COしていない場合
					attackList.add(agent);
				}
			}
		}
	}
	/**
	 * 霊媒師COしたプレイヤを襲撃対象にする
	 * @param target 生きている村人
	 */
	void attackCOMEDIUM(List<Agent> target) {
		if(attackList.isEmpty()) {//襲撃対象がいない場合
			for(Agent agent:target) {
				if(comingoutMap.get(agent)==Role.MEDIUM ) {//霊媒師COしている場合
					attackList.add(agent);
				}
			}
		}
	}
	/**
	 * 占い師COしたプレイヤを襲撃する
	 * @param target 生きている村人
	 */
	void attackCOSEER(List<Agent> target) {
		if(attackList.isEmpty()) {//襲撃対象がいない場合
			for(Agent agent:target) {
				if(comingoutMap.get(agent)==Role.SEER) {//占い師COしている場合
					attackList.add(agent);
				}
			}
		}
	}

}